『No5: Go 错误信息处理』

0.114字数 848阅读 954
golang-learning-five.png
5.png

大家好,我叫谢伟,是一名程序员。

我正在着手扎实学习 golang , 这个专栏是我的输出整理文章。

希望能带有心人一起学习 golang , 力求从入门到中级程序员水平。

我们已经研究了:

这些知识的学习,其实我们已经可以开始写一些代码,不断的熟悉起来了。但不够。

代码毕竟是人写的,谁也不能保证写的代码能够正确无误的运行下去。人会生病,需要找医生,吃药。代码也一样,需要进行错误处理,这个错误处理相当于代码的医生一样。

在 golang 里,错误的处理比较简单,实现接口即可。

但是复杂的项目还是需要对错误进行分类:

  • 错误的状态码
  • 错误的提示信息
  • 在合适的地方显示错误提示信息

本节的主题是: 错误处理

需要指出的是 golang 不支持捕获异常, 比如 python 中的 try...except...finally


  • err 变量
  • error 接口
  • panic
  • recover 、defer

0. err

在golang 中如果需要进行错误处理,一般都默认函数的最后一个返回值是 err。

比如:

func example(arg int) (int, error) {
    return arg + 1, nil
}

再比如看内置读取文件的ioutil.ReadAll 的定义

func ReadAll(r io.Reader) ([]byte, error) {
    return readAll(r, bytes.MinRead)
}

可以看出,一般函数的最后一个返回值定义为 err, 可以通过这个 错误信息判断函数是否执行正确。

1. error 接口

type error interface {
    Error() string
}

内置 errors 包实现了这个接口:

package errors

// New returns an error that formats as the given text.
func New(text string) error {
    return &errorString{text}
}

// errorString is a trivial implementation of error.
type errorString struct {
    s string
}

// 实现了 error 接口的Error 方法
func (e *errorString) Error() string {
    return e.s
}

// 带格式输出的 error 
func Errorf(format string, a ...interface{}) error {
    return errors.New(Sprintf(format, a...))
}

所以可以通过下面两种方法创建包含错误文本的 error 对象:

  • errors.New
  • fmt.Errorf 带格式化输出的 error 对象
// errors.New
func exampleReadAllError() error {
    _, err := ioutil.ReadAll(nil)
    return err
}

// fmt.Errorf

func exampleErrorf(arg int) error {
    return fmt.Errorf("%d", arg)

}

2. panic

在 golang 中遇到错误,需要强制退出程序,可以使用 panic 。panic 接收的参数是任意类型。

func panic(v interface{})
func examplePanic() {
    panic(nil)
}

func main(){
      examplePanic()
}

>>>
panic: nil

goroutine 1 [running]:
main.examplePanic()
    C:/Users/wuxiaoshen/go/src/go-example-for-live/five_learning/main.go:28 +0x3a
main.main()
    C:/Users/wuxiaoshen/go/src/go-example-for-live/five_learning/main.go:37 +0x27

上文中调用 examplePanic 函数会抛出异常,直接终止程序的执行。panic 传入的参数是错误信息。比如上文 nil

除非你确定需要终止程序运行,否则不太使用 panic

3. recover

recover 可以接收返回的异常信息,通常和 defer 一起使用。

比如:

func examplePanic() {
    panic("123")
}

func main() {
    defer func() {
        if err := recover(); err != nil {
            fmt.Println(fmt.Sprintf("recieve error: %s", err))
        }
    }()
    examplePanic()
}

>>>
recieve error: 123

上文操作后,examplePanic 抛出的异常被 recover 接收到,再进行了后面的处理。上文执行就没有错误提示。

当多个 panic 抛出异常是, recover 接收第一个 panic 抛出的异常。

func examplePanic() {
    panic("123")
}

func examplePanicOther() {
    panic("1234")
}

func main() {
    defer func() {
        if err := recover(); err != nil {
            fmt.Println(fmt.Sprintf("recieve error: %v", err))
        }
    }()
    examplePanic()
    examplePanicOther()
    examplePanic()

}

>>>
recieve error: 123

我的博客即将搬运同步至腾讯云+社区,邀请大家一同入驻:https://cloud.tencent.com/developer/support-plan?invite_code=23qzmb5uiug0o

推荐阅读更多精彩内容